
bmap* canvas;
entity* p_terrain;
var canvas_size[2];

//====================================================================================
// THE "SUN"
//====================================================================================

entity* sun_cube;
action Sun_icon
{
  sun_cube = my;
  while(p_terrain == null){wait(1);}
  my.scale_x = 3;
  my.scale_y = 3;
  my.passable = on;
  my.facing = on;
  Set_Suns_Angle();//set sun to initial offset
}

function Set_Suns_Angle()
{
  if(sun_cube)
   {
     if(dynamic_sun)
      {
        sun_cube.x = p_terrain.x + Dyn_sun.x;
        sun_cube.y = p_terrain.y + Dyn_sun.y;
        sun_cube.z = p_terrain.z + Dyn_sun.z;
      }
     else
      {
        sun_cube.x = p_terrain.x + Stat_sun.x;
        sun_cube.y = p_terrain.y + Stat_sun.y;
        sun_cube.z = p_terrain.z + Stat_sun.z;
      }
   }
}

//====================================================================================
// MATERIAL FOR SHADOW MAP
//====================================================================================

material mtl_terrainshadowmap
{
  effect=
  "
  texture entSkin1;
  texture entSkin2;

  technique one_pass_shadow
  {
    pass p0
    {
      Texture[0]=<entSkin1>;
      Texture[1]=<entSkin2>;

      ColorArg1[0]=Texture;
      ColorOp[0]=Modulate2x;
      ColorArg2[0]=Diffuse;
      TexCoordIndex[0]=0;
      TextureTransformFlags[0]=Count2;
      TextureTransform[0]={16.0,0.0,0.0,0.0, // color map u scale
                           0.0,16.0,0.0,0.0, // color map v scale
                           0.0,0.0,0.0,0.0,
                           0.0,0.0,0.0,0.0};

      ColorArg1[1]=Texture;
      ColorOp[1]=Modulate;
      ColorArg2[1]=Current;
      TexCoordIndex[1]=0;
      TextureTransformFlags[1]=Count2;
      TextureTransform[1]={1.0,0.0,0.0,0.0,
                           0.0,1.0,0.0,0.0,
                           0.0,0.0,0.0,0.0,
                           0.0,0.0,0.0,0.0};
    }
  }
  ";
}

//====================================================================================
// BLUR FUNCTION
//====================================================================================

function blur(passes)
{
  var i;
  var px;
  var py;
  var format;
  var pixel;
  var pixelcolor[3];
  var pixelalpha;
  var sample1[3];
  var sample2[3];
  var sample3[3];
  var sample4[3];
  var sample5[3];
  var sample6[3];
  var sample7[3];
  var sample8[3];
  var sample9[3];
  continue_flag = 0;
  i=0;
  while(i<passes)
  {
    py=0;
    while(py<canvas_size.y)
    {
      px=0;
      while(px<canvas_size.x)
      {
        format=bmap_lock(canvas,0);

        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px,0,canvas_size.x-1),clamp(py,0,canvas_size.x-1));
        pixel_to_vec(sample1,pixelalpha,format,pixel);

        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px-1,0,canvas_size.x-1),clamp(py,0,canvas_size.x-1));
        pixel_to_vec(sample2,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px-1,0,canvas_size.x-1),clamp(py+1,0,canvas_size.x-1));
        pixel_to_vec(sample3,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px,0,canvas_size.x-1),clamp(py+1,0,canvas_size.x-1));
        pixel_to_vec(sample4,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px+1,0,canvas_size.x-1),clamp(py+1,0,canvas_size.x-1));
        pixel_to_vec(sample5,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px+1,0,canvas_size.x-1),clamp(py,0,canvas_size.x-1));
        pixel_to_vec(sample6,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px+1,0,canvas_size.x-1),clamp(py-1,0,canvas_size.x-1));
        pixel_to_vec(sample7,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px,0,canvas_size.x-1),clamp(py-1,0,canvas_size.x-1));
        pixel_to_vec(sample8,pixelalpha,format,pixel);
        pixel=pixel_for_bmap(canvas,clamp((canvas_size.x-1)-px-1,0,canvas_size.x-1),clamp(py-1,0,canvas_size.x-1));
        pixel_to_vec(sample9,pixelalpha,format,pixel);

        pixelcolor.x=int((sample1.x*7+sample2.x*2+sample3.x+sample4.x*2+sample5.x+sample6.x*2+sample7.x+sample8.x*2+sample9.x)/19);
        pixelcolor.y=int((sample1.y*7+sample2.y*2+sample3.y+sample4.y*2+sample5.y+sample6.y*2+sample7.y+sample8.y*2+sample9.y)/19);
        pixelcolor.z=int((sample1.z*7+sample2.z*2+sample3.z+sample4.z*2+sample5.z+sample6.z*2+sample7.z+sample8.z*2+sample9.z)/19);

        pixel=pixel_for_vec(pixelcolor,100,format);
        pixel_to_bmap(canvas,(canvas_size.x-1)-px,py,pixel);

        bmap_unlock(canvas);

        px+=1;
      }
      py+=1;
      wait(1); // without a wait after each line the loop could get too big if the shadow map is huge
    }
    i+=1;
  }
 continue_flag = 1;
}

//====================================================================================
// PIXEL LOCATOR FUNCTION
//====================================================================================

function getxyz(px,py)// new vertex method
{
  var pixel_size[2];
  var 1x[3];
  var 2x[3]; 
  var 1y[3];
  var 2y[3];
  //find size of model by corner vertices - Set vert numbers here <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
  vec_for_vertex(1x,p_terrain,TL_vt);//1);//number of top left vertex  min
  vec_for_vertex(2x,p_terrain,TR_vt);//number of top right vertex  max
  vec_for_vertex(1y,p_terrain,BL_vt);//number of bottom left vertex min
  vec_for_vertex(2y,p_terrain,BR_vt);//number of bottom right vertex max

  pixel_size.x=(2x.x - 1x.x)/canvas_size.x;// measure across top rt to lt
  pixel_size.y=(2x.y - 2y.y)/canvas_size.y;// measure down rt side top to bot
  //find corner from center of model
  temp.x=(2x.x -(pixel_size.x*px))-pixel_size.x/2;
  temp.y=(1x.y -(pixel_size.y*py))-pixel_size.y/2;
  // trace 50000 up and down from terrains z to find terrain height at this point

  c_trace(vector(temp.x,temp.y,p_terrain.z+50000),vector(temp.x,temp.y,p_terrain.z-50000),null);//ignore_models+ignore_sprites+ignore_maps);//for hmp

  temp.z=target.z;//target pixels z height
}

//====================================================================================
// DRAW SHADOWS
//====================================================================================

function generate_shadows()
{
  var px;
  var py;
  var format;
  var pixel;
  var photon;
  var photon_dist;
  continue_flag = 0;

  py=0;
  while(py<canvas_size.y)
  {
    px=0;
    while(px<canvas_size.x)
    {
      getxyz(px,py); // get the world coordinates of the pixel

      if(dynamic_sun == 1)//move sun to offset relative to pixel
       {
          vec_set(sun_cube.x,temp.x);//put sun pos at pixel
          sun_cube.x += Dyn_sun.x; //move sun to azmith/elevation
          sun_cube.y += Dyn_sun.y;
          sun_cube.z += Dyn_sun.z;
       }
 
      photon = c_trace(sun_cube.x,vector(temp.x,temp.y,temp.z+1),ignore_passents); // trace from the sun to the pixel
  
      if(result) // draw shadow pixel if there is no obstacle
      {
        format=bmap_lock(canvas,0);

        pixel=pixel_for_vec(vector(shadow_brightness,shadow_brightness,shadow_brightness),100,format);
        pixel_to_bmap(canvas,(canvas_size.x-1)-px,py,pixel);

        bmap_unlock(canvas);
      }

      px+=1; //wait(1);
    }
    py+=1;
    wait(1); // without a wait after each line the loop could get too big if the shadow map is huge
  }
 continue_flag = 1;
}

//====================================================================================
// TERRAIN ACTION
//====================================================================================

action terrain
{
  p_terrain=my;

  my.narrow = on;
  my.fat = on;
  c_setminmax(me);
  my.polygon = on;

  my.material=mtl_terrainshadowmap;
 
  canvas=bmap_for_entity(my,2); // the second texture of the terrain is the shadowmap
  canvas_size.x= bmap_width(canvas);
  canvas_size.y= bmap_height(canvas);

  wait(1);
}
